from PySide2 import QtGui
from PySide2.QtCore import QSize, QPointF
from PySide2.QtGui import QImage, QPainter, QPen


class RenderFragments:
    def __init__(self,width,height):
        self.__width=width
        self.__height=height
        self.__qimage=QImage(width,height,QImage.Format_ARGB32)
        self.__size=QSize(width,height)
        self.__painter = QPainter(self.__qimage)
    def addFragment(self,fragment):
        width=fragment.width
        scale=self.__width/width
        self.__painter.resetTransform()
        self.__painter.translate(self.__size.width() / 2, self.__size.height() / 2)
        self.__painter.scale(scale, scale)
        self.__painter.setPen(QPen(fragment.pen_color, 16))
        self.__painter.setBrush(fragment.brush_color)
        polygon = QtGui.QPolygonF()
        for pnt in fragment.points:
            polygon.append(QPointF(pnt[0],pnt[1]))

        self.__painter.drawPolygon(polygon)
        #self.__painter.end()
    def save(self,path_file):
        self.__painter.end()
        if isinstance(path_file,str):
            self.__qimage.save(path_file)


