from PySide2.QtGui import QImage, QPainter, Qt, QColor

from PanoramaRsc.ui.add_tools.rsc_tools.RSC.add_help.saveBrush.cls_saveBrush import writeImageBytes
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.image_cls.imageMask32.helper import imageToBytes


class MmtoPix:
    def __init__(self,dpi=96):
        self.__dpi=dpi
        self.__mm_in_pix=25.4/dpi
    def toPx(self,value_mm):
        value_pix=int(value_mm/self.__mm_in_pix+0.5)
        return value_pix


def createImage(width_px,dpi=96):

    image=QImage(width_px,width_px, QImage.Format_ARGB32_Premultiplied)
    image.fill(Qt.transparent)
    return image
cls_recalc=MmtoPix()
path_out=r"E:\Download\Panorama\terplan7\custom_brush\pat215.xpm"
width_img_px=cls_recalc.toPx(4)
image=createImage(width_img_px)
paint=QPainter(image)
paint.setBrush(QColor(0,0,0))
width_rec__mm=1.5
width_rect_px=cls_recalc.toPx(width_rec__mm)
x_c=int(width_img_px/2+0.5)
y_c=x_c
x1=x_c-width_rect_px/2
y1=y_c-width_rect_px/2
x1=x1-1
y1=y1-1
x2=x_c+width_rect_px/2
y2=x2
paint.drawRect(x1,y1,width_rect_px,width_rect_px)
#image.save(path_out,"PNG")
data_image=imageToBytes(image,"XPM")
data_image=data_image.replace(b"#ffffff",b'None')
writeImageBytes(data_image,path_out)
print("End")



