from PySide2.QtCore import QPoint
from PySide2.QtGui import QImage, QPainter, Qt, QColor

from PanoramaRsc.ui.add_tools.rsc_tools.RSC.add_help.saveBrush.cls_saveBrush import writeImageBytes
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.image_cls.imageMask32.helper import imageToBytes


class MmtoPix:
    def __init__(self,dpi=96):
        self.__dpi=dpi
        self.__mm_in_pix=25.4/dpi
    def toPx(self,value_mm):
        value_pix=int(value_mm/self.__mm_in_pix+0.5)
        return value_pix


def createImage(width_px,dpi=96):

    image=QImage(width_px,width_px, QImage.Format_ARGB32_Premultiplied)
    image.fill(Qt.transparent)
    return image
cls_recalc=MmtoPix()
path_out=r"E:\Download\Panorama\terplan7\custom_brush\patR220.xpm"
radius__m=0.2
radius__m=1
step_rec__mm=0.5
step_rec__mm=2
step_px=cls_recalc.toPx(step_rec__mm)
radius_px=cls_recalc.toPx(radius__m)
width_img_px=radius_px*2+step_px
if width_img_px %2==0:

    width_img_px=width_img_px+1

image=createImage(width_img_px)
paint=QPainter(image)
paint.setRenderHint(QPainter.RenderHint.Antialiasing)
paint.setBrush(QColor(0,0,0))

x_c=int(width_img_px/2)
y_c=x_c

#paint.drawEllipse(QPoint(x_c-radius_px,y_c-radius_px),radius_px,radius_px)
paint.drawEllipse(QPoint(x_c,y_c),radius_px,radius_px)
#image.save(path_out,"PNG")
data_image=imageToBytes(image,"XPM")
data_image=data_image.replace(b"#ffffff",b'None')
writeImageBytes(data_image,path_out)
print("End")



