from pathlib import Path

from PanoramaRsc.ui.add_tools.helper_db.dbRsc import DbRsc
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.panSymbol import factorySymbol
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.rscPalettes import readPaletteFromDb
from PanoramaRsc.ui.add_tools.rsc_tools.panoramaToAxiPen.factoryAxiPen import convertPanDrawSymbolToAxiPen
class WritePenToFolder:
    def __init__(self,path_folder,start_number_pen):
        self.__path_out=Path(path_folder)
        self.__start_number=start_number_pen
        self.__index_pen=0
    def write(self,obj_trtp):
        cur_pen=self.__start_number+self.__index_pen
        curent_number_str="%03d" % cur_pen
        path_out_pen=self.__path_out.joinpath(curent_number_str+".trtp")
        obj_trtp.writeToFile(str(path_out_pen))
        self.__index_pen=self.__index_pen+1
    def writeByName(self,name,obj_trtp):
        cur_pen = self.__start_number + self.__index_pen
        curent_number_str = "%03d" % cur_pen
        path_out_pen = self.__path_out.joinpath(name + ".trtp")
        if Path(path_out_pen).exists():
            path_out_pen = self.__path_out.joinpath(name+"_1" + ".trtp")
            print("pen file exist :"+path_out_pen)
        obj_trtp.writeToFile(str(path_out_pen))


path_db=r"E:\Download\Panorama\terplan7\terrplan_v7.db"
path_db=r"E:\Download\Panorama\terplan8\terrplan_v8.db"
path_out=r"E:\Download\Panorama\terplan7\temp\Layer_22"
path_out=r"E:\Download\Panorama\terplan8\temp\Common"
palette=readPaletteFromDb(path_db)
dbCls=DbRsc(path_db)
id_layer=22
sql="select obj.code,obj.inner_code,obj.identify_code,obj.object_key,obj.name,obj.location_type,obj.extension_number,displayparams.type,displayparams.descript_bytes from (select * from objects where location_type=0 and layer_number>0  ) as obj ,displayparams where obj.inner_code=displayparams.inner_cod  order by obj.code"
bytes_symbol=None
cls_writer=WritePenToFolder(path_out,4)
records=dbCls.select(sql)
sql_insert="insert into style_object (code,inner_code,identify_code,object_key,name,location_type,extension_number,value_style)  VALUES(?,?,?,?,?,?,?,?)"
for row in records:
    code=row[0]
    inner_code=row[1]
    identificate_code=row[2]
    object_key=row[3]
    name=row[4]
    type_geometry=row[5]
    extention_number=row[6]
    type=row[7]
    bytes_pen_obj=row[8]
    print("Code object:"+str(code)+" Symbol_objId="+object_key)
    print(name)
    try:
        cls_symbolDraw=factorySymbol(bytes_pen_obj,0,type)
        axi_pen=convertPanDrawSymbolToAxiPen(cls_symbolDraw,palette)
        trtp_strings=axi_pen.toStrings()
        trtp_string='\n'.join(trtp_strings)
        values=(code,inner_code,identificate_code,object_key,name,type_geometry,extention_number,trtp_string)
        dbCls.insert(sql_insert,values)
    except:
        print("Error object:"+str(code)+" Symbol_objId="+object_key)
jkl=0
dbCls.close()
print("End")