import io

from osgeo import ogr
import sys

def getGeometry(obj):
    temp_file=io.StringIO()
    obj.export(temp_file,0)
    string_geo_obj=temp_file.getvalue()
    temp_file.close()
    ogr_geometry=ogr.CreateGeometryFromGML(string_geo_obj)
    srs_name=obj.srsName
    return ogr_geometry,srs_name
def getNameAtt(obj):
    name_exception_words=['gds_collector_', 'gds_elementtree_node_', 'original_tagname_', 'parent_object_', 'ns_prefix_', 'id', 'id_nsprefix_', 'metaDataProperty', 'metaDataProperty_nsprefix_', 'description', 'description_nsprefix_', 'descriptionReference', 'descriptionReference_nsprefix_', 'identifier', 'identifier_nsprefix_', 'name', 'name_nsprefix_', 'extensiontype_', 'boundedBy', 'boundedBy_nsprefix_', 'location', 'location_nsprefix_']
    list_att_name_value= {}
    list_obj_att=(obj.__dict__.keys())
    for att_name_obj in list_obj_att:
        if att_name_obj in name_exception_words:
            continue
        if att_name_obj.find('_nsprefix_')>0:
            continue

        att_obj=getattr(obj,att_name_obj)
        class_obj=None
        try:
            class_obj=getattr(att_obj,'__dict__')
        except:
            pass
        #type_obj=type(att_obj)
        #list_att_obj=list(att_obj.__dict__.keys())
        if class_obj is not None:
            type_pref=class_obj['ns_prefix_']
            geo_obj,srs_name=getGeometry(att_obj)
            list_att_name_value['geometry']=geo_obj
            list_att_name_value['srs_name']=srs_name
        else:
            list_att_name_value[att_name_obj]=att_obj
    return list_att_name_value


from PanoramaRsc.ui.add_tools.fgis_tp.fgis_tp_10_izm import parse
path_xml=r"E:\Download\FGIS_TP\Тестовые материалы\Материалы по обоснованию в виде карт (ЗОУИТ).gml"
path_xml=r"E:\Download\FGIS_TP\testGeometry.xml"
objGisTp=parse(path_xml,True)
layer_name=[]
for ftMember in objGisTp.featureMember:
    ft=ftMember.AbstractFeature
    name_layer=ft.original_tagname_
    if not (name_layer in layer_name):
        layer_name.append(name_layer)
    att_values=getNameAtt(ft)
    jkl=0
jkl=0