import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget

from PanoramaRsc.ui.add_tools.panoramaDictionary import PanoramaDictionary
from PanoramaRsc.ui.widgetExportToPanorama import  WidgetExportToPanorama
from PanoramaRsc.ui.widgetImportGml import ImportGml
from PanoramaRsc.ui.widgetInitDbRsc import InitRscAndData


class maintFormTools(QWidget):
    def __init__(self,config_data,parent):
        super().__init__(parent)
        self.__config_data=config_data
        self.__db_dictinory=None
        if self.__config_data is not None:
            self.__db_dictinory=PanoramaDictionary(self.__config_data.PathRscDb)
        self.ui=self.load_ui("rsc_tools_main.ui",parent)
        self.__widget_ini_data=InitRscAndData(self.__config_data,self.ui.tabWidget)
        self.__widget_load_gml=ImportGml(self.__db_dictinory,self.ui.tabWidget)
        self.__widget_export_panorama=WidgetExportToPanorama(self.__config_data,self.ui.tabWidget)
        #self.ui.tabWidget.setTabText(0, "Настройка классификатора")
        #self.ui.tabWidget.setTabText(1, "Загрузка gml ФГИС ТП")

    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def show(self):
        self.ui.show()
    @property
    def widget(self):
        return self.ui
