import os

import axipy
from PySide2.QtCore import QObject
from PySide2.QtGui import QIcon

from PanoramaRsc.ui.dlgExportGmlFgisTp import DlgExportGml


class ToolExportFigisTpGml(QObject):
    def __init__(self, parent_plugin):
        super().__init__()
        self.__name_doc = "Экспорт в Gml"
        self.__parent_plugin = parent_plugin
        self.__local_file_icon_tools = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons',
                                                    'GmlFGisTp34.png')

        self.__iconTools = QIcon(self.__local_file_icon_tools)
        self.__title = self.tr("Экспорт Gml(FGISTP)")
        self.__action = self.__parent_plugin.create_action(
            self.__title,
            icon=self.__local_file_icon_tools,
            on_click=self.__show_dialog,
        )
    def __show_dialog(self):
        dlg_export=DlgExportGml(self.__parent_plugin.configDbRsc,axipy.mainwindow.qt_object())
        dlg_export.exec_()

    @property
    def action(self):
        return self.__action
    def unload(self):
        pass
