from pathlib import Path

import axipy
from PySide2.QtCore import QObject, Signal

from PanoramaRsc.ui.add_tools.helper_tab.add_tab import find_base_table
from PanoramaRsc.ui.add_tools.observers import factoryObserver
from PanoramaRsc.ui.add_tools.saveConfig import ConfigRscDict

class ObserverEnableEditRecord(QObject):
    enable_edit_select=Signal()
    def __init__(self,config):
        super().__init__()
        self.__config=config
        self.__observer_select_from_dict = factoryObserver("PanoramaRscSelect")
        self.__observer_change_config = factoryObserver("PanoramaRscConfigChanged")
        self.__observer_change_config.changed.connect(self.__update_config)
        self.__initObserver()
        self.__active_table=None
        self.__base_table_active=None
    def __initObserver(self):
        def change_select():
            self.__active_table = None
            self.__base_table_active = None
            if axipy.selection_manager.count==0:
                self.__observer_select_from_dict.value=False
                return
            tab_sel= axipy.data_manager.selection
            base_table=find_base_table(tab_sel)
            if base_table.provider!='SqliteDataProvider':
                self.__observer_select_from_dict.value = False
                return
            path_file_db=base_table.properties['fileName']
            if Path(path_file_db)==self._ObserverEnableEditRecord__config.PathDb:
                self.__active_table=tab_sel
                self.__base_table_active=base_table
                self.__observer_select_from_dict.value = True
                self.enable_edit_select.emit()
                return
            self.__observer_select_from_dict.value = False
            return

        axipy.selection_manager.changed.connect(change_select)
    @property
    def activeTable(self):
        return self.__active_table,self.__base_table_active
    def __change_select(self):
        print("Selection changed")
        jkl=0
    def __update_config(self):
        self.__config=ConfigRscDict.load()
