from enum import Enum

from PySide2.QtGui import Qt

class CapStyle(Enum):
    FlatCap=0 # плоский
    SquareCap=1 # прямоугольный
    RoundCap=2 # скругленный
    @staticmethod
    def toString(cap_style):
        if cap_style==CapStyle.FlatCap:
            return "FlatCap"
        if cap_style==CapStyle.SquareCap:
            return "SquareCap"
        if cap_style==CapStyle.RoundCap:
            return "RoundCap"
class JoinStyle(Enum):
    BevelJoin=0 # скос
    MiterJoin=1 # угловой стык
    RoundJoin=2 # скругленный
    @staticmethod
    def toString(join_style):
        if join_style==JoinStyle.RoundJoin:
            return "RoundJoin"
        if join_style==JoinStyle.MiterJoin:
            return "MiterJoin"
        if join_style==JoinStyle.BevelJoin:
            return "BevelJoin"
class UnitPen(Enum):
    px=0
    mm=1
    @staticmethod
    def toString(unit_pen):
        if unit_pen==UnitPen.px:
            return "px"
        if unit_pen==UnitPen.mm:
            return "mm"
class Width:
    def __init__(self,value):
        self.unit=UnitPen.px
        self.value=value

class SubPatternChildren:
    def __init__(self):

        self.enable=True
        self.useStyleColor=True
        self.defaultColor=Qt.white
        self.useStyleWidth=True
        self.baseWidth=1
        self.defaultWidth=Width(1)
        self.opacity=1
        self.joinStyle=JoinStyle.BevelJoin
        self.capStyle=CapStyle.SquareCap
        self.offset=0
        #self.dashPattern=None
        #self.dashOffset=0

        
    '''
    @property
    def enable(self):
        return self.__enable
    @enable.setter
    def enable(self,value):
        self.__enable=value
    @property
    def name(self):
        return self.__name
    @name.setter
    def name(self,value):
        self.__name=value

    @property
    def useStyleColor(self):
        return self.__useStyleColor

    @useStyleColor.setter
    def useStyleColor(self, value):
        self.__useStyleColor = value

    @property
    def defaultColor(self):
        return self.__defaultColor

    @defaultColor.setter
    def defaultColor(self, value):
        self.__defaultColor = value

    @property
    def useStyleWidth(self):
        return self.__useStyleWidth

    @useStyleWidth.setter
    def defaultColor(self, value):
        self.__useStyleWidth = value

    @property
    def baseWidth(self):
        return self.__baseWidth

    @baseWidth.setter
    def defaultColor(self, value):
        self.__baseWidth = value
    '''
class SubPatternMainLine(SubPatternChildren):
    def __init__(self):
        super().__init__()
class SubPatternContinuousMarker(SubPatternChildren):
    def __init__(self):
        super().__init__()
        self.dashPattern=None
        self.dashOffset=0
        self.fill=False
        self.path=None
        self.bend=True
class MapInfoPen:
    def __init__(self):
        pass
def factorymainLine():
    return SubPatternMainLine()
