from PySide2.QtCore import QObject, Signal
from loguru import logger

from PanoramaRsc.ui.add_tools.helper_db.SqliteDataSource import DbSqliteDataSource
from PanoramaRsc.ui.add_tools.helper_db.dbRsc import DbRsc
from PanoramaRsc.ui.add_tools.importGmlFgis import CalcIntProcent
from PanoramaRsc.ui.add_tools.panoramaDictionary import PanoramaDictionary


class TaskCreateDbGpkg(QObject):
    change_name_layer=Signal(str)
    change_progress=Signal(int)
    def __init__(self,name_layers:list,path_db_dict,path_out_gpkg:str,cs_out=None):
        super().__init__()
        self.__name_layers=name_layers
        self.__path_db_dict=path_db_dict
        self.__out_gpkg=path_out_gpkg
        self.__out_cs=cs_out
        self.__isCancel=False
    def run(self):
        logger.debug("Start")
        self.__isCancel = False
        self.__dbSp=DbSqliteDataSource()
        self.__dbSp.create(self.__out_gpkg)
        self.__dbDict=PanoramaDictionary(self.__path_db_dict)
        self.__cls_proc=CalcIntProcent(len(self.__name_layers))
        for i,name_layer in enumerate(self.__name_layers):

            self.change_name_layer.emit(name_layer)
            proc = self.__cls_proc.getValue(i)
            if proc is not None:
                self.change_progress.emit(proc)
            if self.__isCancel:
                break
            logger.debug("Create layer:"+name_layer)
            isOkCreateLayer=self.__createLayer(name_layer,self.__out_cs)
        self.__dbDict.close()
        self.__dbSp.close()
    def __createLayer(self,name_layer,cs_axi):
        logger.debug("Srs layer:" + cs_axi.name)
        srs_wkt=cs_axi.wkt
        logger.debug(srs_wkt)
        #logger.debug(self.__dbDict.isOk)
        #logger.debug(self.__db_dict.getLayers())


        layer_info=self.__dbDict.getLayerByName(name_layer)
        logger.debug("Ok layerRsc att")
        isOkLayer=False

        name_exist_layer=self.__dbSp.getLayer(name_layer)
        if name_exist_layer is not None:
            name_exist_layer=None
        else:
            isOkLayer=self.__dbSp.createLayer(layer_info, cs_axi)
            logger.debug(isOkLayer)

        return isOkLayer
    def setCancel(self):
        self.__isCancel=True