import io

from axipy import LineString, Polygon, MultiPolygon, MultiLineString
from osgeo import ogr, osr
from PanoramaRsc.ui.add_tools.fgis_tp.fgis_tp_10_izm import *

def transformAxiGeometryToOgr(geo_axi,out_type_geometry):
    geo_work_axi=geo_axi
    if out_type_geometry==ogr.wkbMultiCurve:
        if isinstance(geo_work_axi,Polygon) or isinstance(geo_work_axi,MultiPolygon):
            geo_work_axi=geo_axi.to_linestring()
    if out_type_geometry==ogr.wkbMultiSurface:
        if isinstance(geo_work_axi,LineString) or isinstance(geo_work_axi,MultiLineString):
            geo_work_axi=geo_axi.to_polygon()
    geo_wkb=geo_work_axi.to_wkb()
    if geo_wkb is None:
        return None
    geo_ogr=ogr.CreateGeometryFromWkb(geo_wkb)
    geo_out=ogr.Geometry(out_type_geometry)
    geo_out.AddGeometryDirectly(geo_ogr)
    if geo_out.IsEmpty():
        return None

    #srs.ImportFromProj4(cs_out.proj)

    geo_ogr=None
    geo_wkb=None
    return geo_out
def OgrGeometryToGeometryXml(geo_ogr):
    opts = ["FORMAT=GML32","SRSNAME_FORMAT=SHORT","NAMESPACE_DECL=YES"]
    geo_gml=geo_ogr.ExportToGML(opts)

    #buffer_string='<?xml version="1.0" encoding="UTF-8"?>'+geo_gml
    #buffer_string =  geo_gml
    #str_gml_io=io.StringIO(geo_gml)

    xml_spatial=parseString(geo_gml,True)
    #xml_spatial = parse(str_gml_io,True)
    #str_gml_io.close()
    #str_gml_io=None

    return xml_spatial

