from pathlib import Path

from osgeo import ogr, osr

from PanoramaRsc.ui.add_tools.helper_db.dbRsc import DbRsc
from PanoramaRsc.ui.add_tools.helper_db.db_add_helper import TypeGeometry, RscAttribute, TypeNameLayer, RscLayer

base_name_view="vieq_code_"
name_table_layers_info="layer_info_spr"
class DbSqliteDataSource:
    def __init__(self):
        self.__connect=None
        self.__path=None
        self.__dbRsc=None
        self.__ds=None
    def connect(self,path_db):
        pass
    def create(self,path_db,name_driver="GPKG"):
        self.__sqlite_dr = ogr.GetDriverByName(name_driver)
        self.__path=path_db
        if name_driver=="SQLite":
            dsco = ["SPATIALITE=YES"]
            self.__ds=self.__sqlite_dr.CreateDataSource(path_db, options=dsco)
        else:
            self.__ds = self.__sqlite_dr.CreateDataSource(path_db,)
        if self.__ds is None:
            return False
        '''
        self.__path=path_db
        self.__dbRsc=DbRsc(self.__path)
        self.__dbRsc.connect()
        self.__createForeign_key_layers()
        sql_create="CREATE TABLE [layer_info_spr]([id_layer] INTEGER PRIMARY KEY,[name] TEXT,[short_name] TEXT,[full_name] TEXT,[type_geometry] INTEGER, [display_orderIndex] INTEGER)"
        self.__dbRsc.runSqlNoResult(sql_create)
        '''
        sql_create = "CREATE TABLE [layer_info_spr]([id_layer] INTEGER PRIMARY KEY,[name] TEXT,[short_name] TEXT,[full_name] TEXT,[type_geometry] INTEGER, [display_orderIndex] INTEGER)"
        self.__ds.ExecuteSQL(sql_create)
        return True
    def open(self,path_db):
        self.__path=path_db
        self.__ds=ogr.Open(path_db,1)
        return self.__ds is not None
    def createSpatial(self,path_db,name_driver="GPKG"):
        self.__sqlite_dr = ogr.GetDriverByName(name_driver)
        isCreate=True
        if Path(path_db).exists():
            isCreate=False
        if isCreate:
            if name_driver=="SQLite":
                dsco = ["SPATIALITE=YES"]
                self.__ds=self.__sqlite_dr.CreateDataSource(path_db, options=dsco)
            else:
                self.__ds = self.__sqlite_dr.CreateDataSource(path_db,)
        else:
            self.__ds=ogr.Open(path_db,1)
        if self.__ds is None:
            return False
        self.__path=path_db

        return True

    @property
    def PathDb(self):
        return self.__path
    def createLayer(self,layer_info:RscLayer,cs_axi,type_name=TypeNameLayer.Short):
        name=layer_info.ShortName
        if type_name==TypeNameLayer.Full:
            name=layer_info.Name
        attribute=layer_info.Attribute
        name_layer=self.createTable(name,attribute,cs_axi,layer_info.TypeGeometry)
        if name_layer is None:
            return False
        self.__insertLayerInfo(layer_info)
        return True
    def getLayer(self,name):
        return self.__ds.GetLayer(name )
    def __insertLayerInfo(self,layer_info:RscLayer):
        #sql_insert_in_table = "Insert Into "+name_table_layers_info+" "
        type_geometry=6
        if isinstance(layer_info.TypeGeometry,TypeGeometry):
            type_geometry=layer_info.TypeGeometry.value
        else:
            type_geometry=layer_info.TypeGeometry
        sql_insert_info_layer = "Insert into " + name_table_layers_info + "(id_layer,name,short_name,full_name,type_geometry,display_orderIndex) VALUES("
        sql_insert_info_layer=sql_insert_info_layer+str(layer_info.IdLayer)+",'"+layer_info.Name+"','"+layer_info.ShortName+"','"+layer_info.FullName
        sql_insert_info_layer = sql_insert_info_layer+"',"+str(type_geometry)+","+str(layer_info.OrderDisplay)+")"
        self.__ds.ExecuteSQL(sql_insert_info_layer)
        return
    def createTable(self,name,attribytes,cs_axi,type_geometry=None):
        srs = osr.SpatialReference()
        if cs_axi is None:
            srs.ImportFromEPSG(4326)
        else:
            if isinstance(cs_axi,str):
                srs.ImportFromWkt(cs_axi)
            else:
                epsg_axi=cs_axi.epsg
                if epsg_axi is None:
                    srs.ImportFromWkt(cs_axi.wkt)
                else:
                    srs.ImportFromEPSG(epsg_axi)
        ogr_type_geometry=ogr.wkbUnknown
        if type_geometry==TypeGeometry.PolyLine or type_geometry==TypeGeometry.Vector:
            ogr_type_geometry=ogr.wkbLineString
        if type_geometry==TypeGeometry.Any:
            ogr_type_geometry = ogr.wkbUnknown
        if type_geometry == TypeGeometry.Polygon:
            ogr_type_geometry = ogr.wkbPolygon
        if type_geometry == TypeGeometry.Point:
            ogr_type_geometry = ogr.wkbPoint
        layer=self.__ds.CreateLayer(name, srs, geom_type=ogr_type_geometry)
        if attribytes is not None:
            for att in attribytes:
                ogr_def=att.getOgrFieldDefn()
                if ogr_def is None:
                    continue
                layer.CreateField(ogr_def)
        ogeDefMiStyle=RscAttribute.getOgrFieldDefnMiStyle("mi_style")
        layer.CreateField(ogeDefMiStyle)
        #layer.FlushCache()

        if layer is not None:
            layer=None
            return name
        return None
    def close(self):
        if self.__ds is not None:
            self.__ds.FlushCache()
            self.__ds==None
            #self.__path=None


            return

    @staticmethod
    def CreateRscLayer(sp_db,layer):
        sp_db.createTable(layer.Name, layer.Attribute, None, layer.TypeGeometry)

        sql_insert_info_layer="Insert into "+name_table_layers_info+"(id_layer,name,full_name,type_geometry,display_orderIndex) VALUES(?,?,?,?,?)"
        type_geometry=0
        if isinstance(layer.TypeGeometry,int):
            type_geometry=layer.TypeGeometry
        else:
            type_geometry=layer.TypeGeometry.value
        values=(layer.IdLayer,layer.Name,layer.FullName,type_geometry,layer.OrderDisplay)
        sp_db.__dbRsc.insert(sql_insert_info_layer,values)
        sp_db.__dbRsc.commit()
        return
        ''' Create справочники для слоя'''
        dictionary_main_objectId=layer.ObjectIdDictionary
        dbRsc=sp_db.DbSqlite

        #sp_db.close()
        #dbRsc=DbRsc(sp_db.PathDb)
        #isConnect=dbRsc.connect()
        name_add_tab=factoryObjectIdDictionaryDb(dbRsc,layer.Name,dictionary_main_objectId)
        sql="Insert into foreign_key_layers (id_layer, name_children_dict,name_field_base ,name_field_fk,name_filed_children,type_key)  VALUES(?, ?,?,?,?,?)"
        record=(layer.IdLayer,name_add_tab,"objectkey","id_code","name",1)
        dbRsc.insert(sql,record)
        ''' Добавляем справочники на поля '''
        for att in layer.Attribute:
            sp_db.add_dictionary_on_field(layer.IdLayer,att)
        #dbRsc.close()
        dbRsc.commit()
    @staticmethod
    def strEpsgToWkt(str_epsg):
        params_epsg=str_epsg.split(":")
        if len(params_epsg)!=2:
            return None
        code_epsg=int(params_epsg[1])
        srs = osr.SpatialReference()
        srs.ImportFromEPSG(code_epsg)
        return srs.ExportToWkt()
    def add_dictionary_on_field(self,id_layer,att):
        name_view = base_name_view + str(att.InnerCode)
        sql='SELECT name from sqlite_master  WHERE type ="view" and name = "'+name_view+'"'
        records=self.__dbRsc.select(sql)
        if len(records)==0:
            return
        sql="Insert into foreign_key_layers (id_layer, name_children_dict,name_field_base ,name_field_fk,name_filed_children,type_key)  VALUES(?, ?,?,?,?,?)"
        record = (id_layer, name_view, att.Name.lower(),"id_code","name",0)
        self.__dbRsc.insert(sql, record)

    def temp_close(self):
        self.__ds.FlushCache()
        self.__ds=None
    def __reopen(self):
        self.__ds=None

def factoryObjectIdDictionaryDb(dbRsc,name_layer,dictionary_main_objectId):
    name_tab=name_layer+"_dict_object_id"
    sql="create table "+name_tab+" (id_code TEXT,value TEXT, "
    sql=sql+" CONSTRAINT object_key UNIQUE (id_code) )"
    dbRsc.runSqlNoResult(sql)
    sql_insert = "Insert into " + name_tab + " (id_code, value)  VALUES(?, ?)"
    values=[]
    for att in dictionary_main_objectId:
        #rcord=(att.ObjectKey,att.Name)
        #dbRsc.insert(sql_insert,rcord)
        values.append((att.ObjectKey,att.Name))
    #sql_insert="Insert into "+name_tab+" (id_code, value)  VALUES(?, ?)"
    dbRsc.insertMany(sql_insert,values)
    return name_tab









