from axipy import CoordSystem
from loguru import logger
from osgeo import ogr


class OgrLayer:
    def __init__(self,layer_ogr,cs_axi):
        self.__layer=layer_ogr
        self.__featureDefn=layer_ogr.GetLayerDefn()
        self.__names_ft=[]
        self.__source_cs=cs_axi
        self.__existMiStyle=False
        self.__cs_out=None

    def addFeature(self,ft_axi,start=False):
        items_info = ft_axi.items()
        geo_wkb=None
        geo_ogr=None
        feature=None
        if start:
            cs_out=CoordSystem.from_proj(self.__layer.GetSpatialRef().ExportToProj4())
            if not (cs_out==self.__source_cs):
                self.__cs_out=cs_out
            self.__layer.StartTransaction()

            for item in items_info:
                name_att=item[0]
                if name_att.lower()=='objectkey':
                    name_att='classid'

                index_att_in_layer=self.__featureDefn.GetFieldIndex(name_att)
                if index_att_in_layer>=0:

                    self.__names_ft.append((name_att,item[0]))

                    #self.__names_ft.append(name_att)
            if self.__featureDefn.GetFieldIndex("mi_style")>=0:
                self.__existMiStyle=True
        feature = ogr.Feature(self.__featureDefn)
        for name_att in self.__names_ft:
            #if isinstance(name_att,tuple):
            feature.SetField(name_att[0],ft_axi[name_att[1]])
            #else:
            #    feature.SetField(name_att, ft_axi[name_att])
        if ft_axi.geometry is not None:
            if self.__cs_out is None:
                geo_wkb=ft_axi.geometry.to_wkb()
            else:
                try:
                    geo_wkb = ft_axi.geometry.reproject(self.__cs_out).to_wkb()
                except:
                    logger.error("error convert wkb geometry:"+ft_axi.geometry.name)
                    geo_wkb=None
            if geo_wkb is None:
                geo_wkb = None
                geo_ogr = None
                feature = None
                return
            geo_ogr=ogr.CreateGeometryFromWkb(geo_wkb)
            feature.SetGeometry(geo_ogr)
            if self.__existMiStyle:
                str_mi_style=ft_axi.style.to_mapinfo()
                feature.SetField("mi_style", str_mi_style)
        self.__layer.CreateFeature(feature)
        geo_wkb = None
        geo_ogr = None
        feature = None
    def end_write(self):
        self.__layer.CommitTransaction()

