from PySide2.QtCore import QObject, Signal
from axipy import Feature, Polygon, MultiPolygon, LineString, MultiLineString, Point, MultiPoint

from PanoramaRsc.ui.add_tools.helper_db.db_add_helper import TypeGeometry


def axiTypeGeometryToRscGeomtry(geometry):
    if isinstance(geometry,Polygon) or isinstance(geometry,MultiPolygon):
        return TypeGeometry(1)
    if isinstance(geometry,LineString) or isinstance(geometry,MultiLineString):
        return TypeGeometry(0)
    if isinstance(geometry,Point) or isinstance(geometry,MultiPoint):
        return TypeGeometry(2)
    return TypeGeometry.Any

def CloneFeature(ft:Feature,geometry=None):
    att_source=ft.items()
    att_new={}
    for att_s in att_source:
        att_new[att_s[0]]=att_s[1]
    if geometry is not None:
        return Feature(att_new, geometry=geometry, style=ft.style)
    return Feature(att_new,geometry=ft.geometry,style=ft.style)
class TableItemsReprojectIterator:

    def __init__(self,source_iterator,out_cs,type_geometry):

        self.__source_iterator=source_iterator
        self.__out_cs=out_cs
        self.__type_geometry=type_geometry


    def __iter__(self):
        return self

    def __next__(self):

        ft=next(self.__source_iterator)
        geometry=ft.geometry
        new_geometry=None
        if geometry is not None:
            '''
            
            '''
            geometry_type=axiTypeGeometryToRscGeomtry(geometry)
            if self.__type_geometry!=geometry_type:
                if geometry_type==TypeGeometry.Polygon and self.__type_geometry==TypeGeometry.PolyLine:
                    new_geometry=geometry.to_linestring()
                else:
                    if geometry_type==TypeGeometry.PolyLine and self.__type_geometry==TypeGeometry.Polygon:
                        new_geometry=geometry.to_polygon()
            if new_geometry is not None and self.__out_cs is not None:
                new_geometry = new_geometry.reproject(self.__out_cs)
            else:
                if self.__out_cs is not None:
                    new_geometry = geometry.reproject(self.__out_cs)
            #new_geometry=geometry.reproject(self.__out_cs)
            if new_geometry is not None:
                clone_ft=CloneFeature(ft,new_geometry)
                return clone_ft
            #clone_ft.geometry=new_geometry

        return ft
