from loguru import logger

from PanoramaRsc.ui.add_tools.helper_db.clsDb import LayerInfo, getTypeGeometry
from PanoramaRsc.ui.add_tools.helper_db.dbRsc import DbRsc
from PanoramaRsc.ui.add_tools.helper_db.db_add_helper import RscLayer


class PanoramaDictionary:
    __tab_layers = 'layers'
    __tab_full_names = 'full_names_layers'
    __table_link_key = "foreign_key_layers"
    __table_spatial_type = "layer_info_dict_spatial"
    __ObjectId_code = 32800
    def __init__(self,path_dict_db=None):
        self.__path_dict_db=path_dict_db
        if self.__path_dict_db is not None:
            self.connectDbDict(self.__path_dict_db)
    def connectDbDict(self,path_db):
        self.__db=DbRsc(path_db)
        isOk=self.__db.connect()
        self.isOk=isOk

        return isOk
    @property
    def pathDb(self):
        return self.__path_dict_db
    '''
    Получаем список слоев классфикатора 
    '''
    def getLayers(self)->list:
        name_tab=self.__tab_layers
        name_full_names=self.__tab_full_names
        name_full_spatial_type=self.__table_spatial_type
        sql="select lyr.*,full.name as full_name,sp.type_geometry from "+name_tab+" as lyr,"+name_full_names+" as full,"+name_full_spatial_type+" as sp where lyr.id_layer==full.code_object and  lyr.id_layer==sp.id_layer order by lyr.name"
        rows=self.__db.select(sql)
        list_layer_info=[]
        for row in rows:
            if row[2]=="SYSTEM":
                continue
            id_layer=row[0]
            rsc_layer=RscLayer.factory(self.__db,id_layer)
            rsc_layer.setName(row[1])
            #list_layer_info.append(LayerInfo(row[0],row[1],row[2],row[3],row[4],getTypeGeometry(row[5])))
            list_layer_info.append(rsc_layer)
        return list_layer_info
    def reOpen(self):
        logger.debug("Close db")
        if self.isOk:
            self.close()
        logger.debug("Close db 1")
        self.connectDbDict(self.__path_dict_db)

    def getLayerByName(self,name_layer):
        logger.debug(name_layer)
        name_tab = self.__tab_layers
        name_full_names = self.__tab_full_names
        name_full_spatial_type = self.__table_spatial_type
        sql = "select lyr.*,full.name as full_name,sp.type_geometry from " + name_tab + " as lyr," + name_full_names + " as full," + name_full_spatial_type + " as sp where lyr.id_layer==full.code_object and  lyr.id_layer==sp.id_layer and (lyr.name='"+name_layer+"' or lyr.short_name='"+name_layer+"') "
        logger.debug(sql)
        rows = self.__db.select(sql)
        logger.debug(len(rows))
        if len(rows)==0:
            return None
        row=rows[0]
        id_layer = row[0]
        rsc_layer = RscLayer.factory(self.__db, id_layer)
        rsc_layer.setName(row[1])
        return rsc_layer
    def select(self,sql):
        return self.__db.select(sql)
    def close(self):
        self.__db.close()
        self.isOk=False



