import axipy
from PySide2.QtCore import QObject, Signal
from loguru import logger

from PanoramaRsc.ui.add_tools.helper_db.SqliteDataSource import DbSqliteDataSource
from PanoramaRsc.ui.add_tools.helper_db.layer_ogr import OgrLayer
from PanoramaRsc.ui.add_tools.importGmlFgis import CalcIntProcent


class PanoramaToGpkg(QObject):
    change_name_layer = Signal(str)
    change_proc = Signal(int)
    def __init__(self,names_layer:list,path_source_pan,path_out_gpkg:str):
        super().__init__()
        self.__layers_name=names_layer
        self.__path_gpkg=path_out_gpkg
        self.__path_source_pan=path_source_pan
        self.__isCancel=False
        self.__data_object=None
    def run(self):
        logger.debug("Start import panoram data ")
        logger.debug("Import panoram:"+self.__path_source_pan)
        definition_ds={'src':self.__path_source_pan}
        self.__data_object=axipy.provider_manager.open(definition_ds)
        cs_source=self.__data_object.schema.coordsystem
        db_sp = DbSqliteDataSource()
        logger.debug("Dest Db:" + self.__path_gpkg)
        db_sp.open(self.__path_gpkg)
        ogr_layer=None
        for i,name_layer in enumerate(self.__layers_name):

            self.change_name_layer.emit(name_layer)
            if self.__isCancel:
                break
            count=len(list(self.__data_object.items(name_layer)))
            if count==0:
                procent = cls_proc_ft.getValue(0)
                continue
            layer=db_sp.getLayer(name_layer)
            if layer is None:
                logger.debug("Слой :"+name_layer+" не найдет в gpkg")
                continue
            cls_ogrLayer=OgrLayer(layer,cs_source)
            cls_proc_ft=CalcIntProcent(count)
            isStartFeature=True
            for i,ft in enumerate(data_object.items(name_layer)):
                procent=cls_proc_ft.getValue(i)
                if procent is not None:
                    self.change_proc.emit(procent)
                if self.__isCancel:
                    break
                cls_ogrLayer.addFeature(ft,isStartFeature)
                isStartFeature=False
            cls_ogrLayer.end_write()
            self.change_proc.emit(100)
            layer=None
        db_sp.close()
        if self.__data_object is not None:
            self.__data_object.close()
            self.__data_object=None
    def setCancel(self):
        self.__isCancel=True
    @property
    def IsCancel(self):
        return self.__isCancel
    def closeDataPanorama(self):
        if self.__data_object is not None:
            self.__data_object.close()
            self.__data_object=None


