from pathlib import Path

from osgeo import ogr, osr

from PanoramaRsc.ui.add_tools.rsc_tools.PanoramaMap.add_tools.db_add_helper import TypeGeometry, RscAttribute
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.add_help.dbRsc import DbRsc

#from MyTask.Panorama.PanoramaMap.add_tools.db_add_helper import TypeGeometry, RscAttribute
#from MyTask.Panorama.RSC.add_help.dbRsc import DbRsc

base_name_view="vieq_code_"
name_table_layers_info="layer_info_spr"
class DbSqliteDataSource:
    def __init__(self):
        self.__connect=None
        self.__path=None
        self.__dbRsc=None
        self.__ds=None
    def connect(self,path_db):
        pass
    def create(self,path_db,name_driver="SQLite"):
        self.__sqlite_dr = ogr.GetDriverByName(name_driver)
        if name_driver=="SQLite":
            dsco = ["SPATIALITE=YES"]
            self.__ds=self.__sqlite_dr.CreateDataSource(path_db, options=dsco)
        else:
            self.__ds = self.__sqlite_dr.CreateDataSource(path_db,)
        if self.__ds is None:
            return False
        self.__path=path_db
        self.__dbRsc=DbRsc(self.__path)
        self.__dbRsc.connect()
        self.__createForeign_key_layers()
        sql_create="CREATE TABLE [layer_info_spr]([id_layer] INTEGER PRIMARY KEY,[name] TEXT,[short_name] TEXT,[full_name] TEXT,[type_geometry] INTEGER, [display_orderIndex] INTEGER)"
        self.__dbRsc.runSqlNoResult(sql_create)
        return True
    def createSpatial(self,path_db,name_driver="GPKG"):
        self.__sqlite_dr = ogr.GetDriverByName(name_driver)
        isCreate=True
        if Path(path_db).exists():
            isCreate=False
        if isCreate:
            if name_driver=="SQLite":
                dsco = ["SPATIALITE=YES"]
                self.__ds=self.__sqlite_dr.CreateDataSource(path_db, options=dsco)
            else:
                self.__ds = self.__sqlite_dr.CreateDataSource(path_db,)
        else:
            self.__ds=ogr.Open(path_db,1)
        if self.__ds is None:
            return False
        self.__path=path_db

        return True
    def __createForeign_key_layers(self):
        sql="CREATE TABLE foreign_key_layers (id_layer INTEGER, name_children_dict TEXT,name_field_base TEXT,name_field_fk TEXT,name_filed_children TEXT, type_key INTEGER)"
        self.__dbRsc.runSqlNoResult(sql)
        sql="CREATE INDEX fk_laye_children_dict ON foreign_key_layers](id_layer)"
        self.__dbRsc.runSqlNoResult(sql)
    @property
    def PathDb(self):
        return self.__path
    def copyClassificatorObject(self,dbSource):
        name_tab='classificator_values'
        sql="select Min(id) ,Max(id) from "+name_tab
        records=dbSource.select(sql)
        min_code=records[0][0]
        max_code=records[0][1]
        sql_create="CREATE TABLE classificator_values ( id INTEGER NOT NULL,code INTEGER, name TEXT)"
        self.__dbRsc.runSqlNoResult(sql_create)
        sql_create="CREATE INDEX indx_classificatio_code ON classificator_values(code);"
        self.__dbRsc.runSqlNoResult(sql_create)
        for code in range(min_code,max_code+1):
            sql_source="select * from "+name_tab+" where id="+str(code)
            records=dbSource.select(sql_source)
            if len(records)==0:
                continue
            sql_insert = "Insert into " + name_tab + " (id, code,name)  VALUES(?, ?,?)"
            self.__dbRsc.insertMany(sql_insert,records)
            sql_view ="CREATE VIEW "+base_name_view+str(code)+" AS SELECT code as id_code,name as value from "+name_tab+" where id="+str(code)
            self.__dbRsc.runSqlNoResult(sql_view)
    def createTable(self,name,attribytes,srs_wkt,type_geometry=None):
        srs = osr.SpatialReference()
        if srs_wkt is None:
            srs.ImportFromEPSG(4326)
        else:
            srs.ImportFromWkt(srs_wkt)
        ogr_type_geometry=ogr.wkbUnknown
        if type_geometry==TypeGeometry.PolyLine or type_geometry==TypeGeometry.Vector:
            ogr_type_geometry=ogr.wkbLineString
        if type_geometry==TypeGeometry.Any:
            ogr_type_geometry = ogr.wkbUnknown
        if type_geometry == TypeGeometry.Polygon:
            ogr_type_geometry = ogr.wkbPolygon
        if type_geometry == TypeGeometry.Point:
            ogr_type_geometry = ogr.wkbPoint
        layer=self.__ds.CreateLayer(name, srs, geom_type=ogr_type_geometry)
        if attribytes is not None:
            for att in attribytes:
                ogr_def=att.getOgrFieldDefn()
                if ogr_def is None:
                    continue
                layer.CreateField(ogr_def)
        ogeDefMiStyle=RscAttribute.getOgrFieldDefnMiStyle("mi_style")
        layer.CreateField(ogeDefMiStyle)
        #layer.FlushCache()
        layer=None
    @property
    def DbSqlite(self):
        return self.__dbRsc
    def close(self):
        if self.__ds is not None:
            self.__ds.FlushCache()
            self.__ds==None
            self.__path=None

            if self.__dbRsc is not None:
                self.__dbRsc.close()
                self.__dbRsc=None
            return
        if self.__dbRsc is not None:
            self.__dbRsc.close()
            self.__dbRsc=None

    @staticmethod
    def CreateRscLayer(sp_db,layer):
        sp_db.createTable(layer.Name, layer.Attribute, None, layer.TypeGeometry)

        sql_insert_info_layer="Insert into "+name_table_layers_info+"(id_layer,name,full_name,type_geometry,display_orderIndex) VALUES(?,?,?,?,?)"
        type_geometry=0
        if isinstance(layer.TypeGeometry,int):
            type_geometry=layer.TypeGeometry
        else:
            type_geometry=layer.TypeGeometry.value
        values=(layer.IdLayer,layer.Name,layer.FullName,type_geometry,layer.OrderDisplay)
        sp_db.__dbRsc.insert(sql_insert_info_layer,values)
        sp_db.__dbRsc.commit()
        return
        ''' Create справочники для слоя'''
        dictionary_main_objectId=layer.ObjectIdDictionary
        dbRsc=sp_db.DbSqlite

        #sp_db.close()
        #dbRsc=DbRsc(sp_db.PathDb)
        #isConnect=dbRsc.connect()
        name_add_tab=factoryObjectIdDictionaryDb(dbRsc,layer.Name,dictionary_main_objectId)
        sql="Insert into foreign_key_layers (id_layer, name_children_dict,name_field_base ,name_field_fk,name_filed_children,type_key)  VALUES(?, ?,?,?,?,?)"
        record=(layer.IdLayer,name_add_tab,"objectkey","id_code","name",1)
        dbRsc.insert(sql,record)
        ''' Добавляем справочники на поля '''
        for att in layer.Attribute:
            sp_db.add_dictionary_on_field(layer.IdLayer,att)
        #dbRsc.close()
        dbRsc.commit()
    def add_dictionary_on_field(self,id_layer,att):
        name_view = base_name_view + str(att.InnerCode)
        sql='SELECT name from sqlite_master  WHERE type ="view" and name = "'+name_view+'"'
        records=self.__dbRsc.select(sql)
        if len(records)==0:
            return
        sql="Insert into foreign_key_layers (id_layer, name_children_dict,name_field_base ,name_field_fk,name_filed_children,type_key)  VALUES(?, ?,?,?,?,?)"
        record = (id_layer, name_view, att.Name.lower(),"id_code","name",0)
        self.__dbRsc.insert(sql, record)

    def temp_close(self):
        self.__ds.FlushCache()
        self.__ds=None
    def __reopen(self):
        self.__ds=None

def factoryObjectIdDictionaryDb(dbRsc,name_layer,dictionary_main_objectId):
    name_tab=name_layer+"_dict_object_id"
    sql="create table "+name_tab+" (id_code TEXT,value TEXT, "
    sql=sql+" CONSTRAINT object_key UNIQUE (id_code) )"
    dbRsc.runSqlNoResult(sql)
    sql_insert = "Insert into " + name_tab + " (id_code, value)  VALUES(?, ?)"
    values=[]
    for att in dictionary_main_objectId:
        #rcord=(att.ObjectKey,att.Name)
        #dbRsc.insert(sql_insert,rcord)
        values.append((att.ObjectKey,att.Name))
    #sql_insert="Insert into "+name_tab+" (id_code, value)  VALUES(?, ?)"
    dbRsc.insertMany(sql_insert,values)
    return name_tab









