from enum import Enum

from osgeo import ogr

name_tab_layer="layers"
name_tab_full_name_layers="full_names_layers"
name_tab_objects="objects"
name_tab_layers_attribute='layers_attribute'
name_tab_semantic_attribute='semantic_attribute'
class TypeGeometry(Enum):
    PolyLine=0
    Polygon=1
    Point=2
    Text=3
    Vector=4
    Label=5
    Any=6
class ObjectDictionary:
    def __init__(self,code,object_key,name,inner_code,type_geometry:TypeGeometry):
        self.code=code
        self.ObjectKey=object_key
        self.Name=name
        self.InnerCode=inner_code
        self.TypeGeometry=type_geometry
    @staticmethod
    def factoryDictonary(dbRsc,id_layer):
        sql="Select * from "+name_tab_objects+" where layer_number="+str(id_layer)
        result=dbRsc.select(sql)
        objects_dictionary=[]
        temp_type_geometry=[]
        for item_obj in result:
            obj_dict=ObjectDictionary(item_obj[0],item_obj[3],item_obj[4],item_obj[1],item_obj[5])
            if not(obj_dict.TypeGeometry in temp_type_geometry):
                temp_type_geometry.append(obj_dict.TypeGeometry)
            objects_dictionary.append(obj_dict)
        type_geometry=TypeGeometry.Any
        if len(temp_type_geometry)==1:
            type_geometry=temp_type_geometry[0]
        return objects_dictionary,type_geometry

class RscAttribute:
    def __init__(self,name,full_name,inner_code,type_att,length,precission):
        self.Name=name
        self.FullName=full_name
        self.InnerCode=inner_code
        self.Type=type_att
        self.length=length
        self.precission=precission
    def getOgrFieldDefn(self):
        if self.Type==0 or self.Type==24:
            ogr_def=ogr.FieldDefn(self.Name, ogr.OFTString)
            ogr_def.SetWidth(self.length)
            return ogr_def
        if (self.Type==1 and self.precission==0) or (self.Type==22 and self.precission==0) or (self.Type==16 and self.precission==0):
            ogr_def = ogr.FieldDefn(self.Name, ogr.OFTInteger)
            return ogr_def
        if self.Type==1 and self.precission>0:
            ogr_def = ogr.FieldDefn(self.Name, ogr.OFTReal)
            return ogr_def
        return None
    @staticmethod
    def getOgrFieldDefnMiStyle(name):
        ogr_def = ogr.FieldDefn(name, ogr.OFTString)
        ogr_def.SetWidth(255)
        return ogr_def


    @staticmethod
    def factoryListRscAttribute(dbRsc,id_layer):
        sql="select * from "+name_tab_layers_attribute+" layer,"+name_tab_semantic_attribute+" att where num_layer="+str(id_layer)+" and layer.code_att=att.code "
        result=dbRsc.select(sql)
        attributes=[]
        for item_res in result:
            att=RscAttribute(item_res[7],item_res[6],item_res[1],item_res[3],item_res[9],item_res[10])
            attributes.append(att)
        return attributes



class RscLayer:
    def __init__(self,id,name,full_name,order_layer=0):
        self.__id_layer=id
        self.__name=name
        self.__full_name=full_name
        self.__attribute=[]
        self.__typeGeometry=None
        self.__order=order_layer
        self.__dictionaryObject=None
    def setDictionaryObjects(self,objs_dict):
        self.__dictionaryObject=objs_dict
    def setTypeGeometry(self,type_geo:TypeGeometry):
        self.__typeGeometry=type_geo
    @property
    def ObjectIdDictionary(self):
        return self.__dictionaryObject
    @property
    def OrderDisplay(self):
        return self.__order
    @property
    def TypeGeometry(self):
        return self.__typeGeometry
    @property
    def Name(self):
        return self.__name
    @property
    def IdLayer(self):
        return self.__id_layer
    @property
    def FullName(self):
        return self.__full_name
    def addAttribute(self,att_def):
        self.__attribute=att_def
    @property
    def Attribute(self):
        return self.__attribute
    @staticmethod
    def factory(dbRsc,id_layer):
        sql="select * from "+name_tab_layer+" layer,"+name_tab_full_name_layers+" names where layer.id_layer="+str(id_layer)+" and layer.id_layer=names.code_object"
        result=dbRsc.select(sql)
        if result is None or len(result)==0:
            return None
        info_layer=result[0]
        rscLayer=RscLayer(info_layer[0],info_layer[1],info_layer[5],info_layer[3])
        objects_dict,type_geometry=ObjectDictionary.factoryDictonary(dbRsc,id_layer)
        if objects_dict is  None:
            return None
        rscLayer.setDictionaryObjects(objects_dict)
        rscLayer.setTypeGeometry(type_geometry)
        attributes_layer=RscAttribute.factoryListRscAttribute(dbRsc,id_layer)
        attObjectKey=RscAttribute("ObjectKey","ObjectKey",0,0,32,0)
        attributes_layer.insert(0,attObjectKey)
        mi_style=RscAttribute("mi_style","mi_style",0,0,255,0)
        rscLayer.addAttribute(attributes_layer)
        return rscLayer

