import axipy
from loguru import logger
from axipy import ForeignRelationFields, foreignkey_manager, data_manager, provider_manager, Table

from PanoramaRsc.ui.add_tools.rsc_tools.PanoramaMap.add_tools.db_add_helper import TypeGeometry


#from MyTask.Panorama.PanoramaMap.add_tools.db_add_helper import TypeGeometry


def connect_change_table(cls_TableRelation):

    table=cls_TableRelation.getTable()
    table_realtion=cls_TableRelation
    def change_table(status_info):
        if status_info['operation']=='insert':
            table_realtion.setDefaultValue(status_info)
        #name=table.name

        jkl=0

    table.data_changed.connect(change_table)
class DbTableInfo:

    Foreign_key_layers="foreign_key_layers"
    SpatialDb="SpatialDb"
    SpDbLayer_info_spr="layer_info_spr"
    DefaultValue='default_values'
    Objects_table="objects"
    DisplayParams="displayparams"

def listTupleTpListDict(tuples,name_key):
    out_list=[]
    for tp in tuples:
        values={}
        for i,key in enumerate(name_key):
            values[key]=tp[i]
        out_list.append(values)
    return out_list
class DefaultValueField:
    def __init__(self,min,max,default,type_geometry=None,mi_style=None):
        self.Min=min
        self.Max=max
        self.default=default
        self.type_geometry=None
        if type_geometry is not None:
            self.type_geometry=TypeGeometry(type_geometry)
        self.mi_style=mi_style
class ForeignKeyField:
    def __init__(self,name_field,name,name_tab,path,name_key,name_value,value_dictinory,defalult_value):
        self.FieldName=name_field
        self.Name=name
        self.NameTabDb=name_tab
        self.PathSource=path
        self.NameKey=name_key
        self.NameValue=name_value
        self.__default_values=defalult_value
        self.__dictionary=value_dictinory
    @property
    def DefaultValue(self):
        return self.__default_values.default
    @property
    def MiStyle(self):
        return self.__default_values.mi_style

class TableRelation:
    def __init__(self,name,alias_table,path_source,dictionarys):
        '''

        :param name:
        :param path_source:
        :param dictionarys: список справочников
        '''
        self.Name=name
        self.Alias=alias_table
        self.PathSource=path_source
        self.__dictoinarys=dictionarys
        self.__table=None
    @property
    def open(self):

        self.__source=axipy.provider_manager.sqlite.get_source(self.PathSource,self.Name)
        self.__baseDefTable={ 'src': self.PathSource,
               'dataobject': self.Name,
                'provider': 'SqliteDataProvider'
              }
        self.__list_source_dictionary=None
        if len(self.__dictoinarys)>0:
            self.__list_source_dictionary=[]
            self.__listRelationFields=[]
        self.__def_relation_tabs=[]
        for dictionary in self.__dictoinarys:
            name_dict = dictionary.Name
            #source_dict = axipy.provider_manager.sqlite.get_source(dictionary.PathSource, name_dict)
            source_dict = axipy.provider_manager.sqlite.get_source(dictionary.PathSource, dictionary.NameTabDb)
            rel_DefTable = {'src': dictionary.PathSource,
                            'dataobject': dictionary.NameTabDb,
                            'provider': 'SqliteDataProvider'
                            }
            self.__def_relation_tabs.append(rel_DefTable)
            self.__list_source_dictionary.append(source_dict)
            relation=ForeignRelationFields(dictionary.FieldName, dictionary.NameKey, dictionary.NameValue)
            foreignkey_manager.register(self.__source,source_dict,relation)
            self.__listRelationFields.append(relation)
        self.__table=self.__source.open()
        if self.__table is not None:
            ''' Подключаемся к событиям '''
            count_fts = self.__table.count()
            #self.__table=self.__reopenTables(self.__table)
            #self.__table.data_changed.connect(self.change_table)
            connect_change_table(self)
        #data_manager.removed[str].connect(lambda n: print(f'Таблица "{n}" удалена из каталога'))
        return self.__table
    def __reopenTables(self,table_base:Table):
        table_base.close()
        table=provider_manager.open(self.__baseDefTable)
        for rel_tab in self.__def_relation_tabs:
            name=rel_tab['dataobject']
            tab_rel=data_manager.find(name)
            tab_rel.close()
            provider_manager.open_hidden(self.__baseDefTable)
        return table
    def getTable(self):
        return self.__table
    def setDefaultValue(self,info_insert):

        ids=info_insert['ids']
        default_col=[]
        mi_style=None
        for dictionry in self.__dictoinarys:
            default_col.append({'name':dictionry.FieldName,"value":dictionry.DefaultValue})
            if dictionry.MiStyle is not None:
                mi_style=axipy.Style.from_mapinfo(dictionry.MiStyle)
        ft_ids=self.__table.itemsByIds(ids)
        update_features=[]
        for ft in ft_ids:

            for def_col in default_col:
                ft[def_col['name']]=def_col['value']
            if (mi_style is not None) and (ft.geometry is not None):
                ft.style=mi_style

            update_features.append(ft)

        self.__table.update(update_features)
    @staticmethod
    def factory(id_layer,dbRsc,path_source):
        sql="select * From "+DbTableInfo.Foreign_key_layers+" where id_layer="+str(id_layer)
        records_fk_keys=dbRsc.select(sql)
        if len(records_fk_keys)==0:
            logger.info("Not find Foreign_key int layer:"+str(id_layer))
            return
        #sql_atach="ATTACH DATABASE '"+path_source+"' as '"+DbTableInfo.SpatialDb+"'"
        #isOk=dbRsc.runSqlNoResult(sql_atach)
        sql_exit_tab_in_sp="Select * from "+DbTableInfo.SpatialDb+"."+DbTableInfo.SpDbLayer_info_spr+" where id_layer="+str(id_layer)

        records=dbRsc.select(sql_exit_tab_in_sp)
        if len(records)==0:
            #dbRsc.runSqlNoResult("DETACH DATABASE '"+DbTableInfo.SpatialDb+"'")
            logger.info("Not find layer:" + str(id_layer)+" in SpatialDb :"+path_source)
            return
        record=records[0]
        nameTable=record[1]
        nameTableLower=nameTable.lower()
        ''' Проверяем есть такая таблица в пространственной базе'''
        sql="SELECT name FROM "+DbTableInfo.SpatialDb+".sqlite_master WHERE type='table' and name='"+nameTableLower+"'"
        records_sp=dbRsc.select(sql)
        if len(records_sp)==0:
            logger.info("Not find layer:" + str(id_layer) + " in SpatialDb :" + path_source)
            return
        dictionarys=[]
        for rk_key in records_fk_keys:
            name_dictionary_tab=rk_key[1]
            name_field_db=rk_key[2]
            name_id_key=rk_key[3]
            name_field_dict=rk_key[4]
            inner_code=rk_key[5]
            priznak=rk_key[6]


            if inner_code==0 and priznak==1:
                sql_dictionary = "select * from " + name_dictionary_tab
                sql_dictionary ='select lr.*,obj.inner_code,obj.location_type,d_parm.mi_style from '+name_dictionary_tab+' lr,'+DbTableInfo.Objects_table+' obj,'+DbTableInfo.DisplayParams+' d_parm where lr.id_code==obj.object_key and d_parm.inner_cod==obj.inner_code'
                recoders_dictionary = dbRsc.select(sql_dictionary)
                dictionary_values = listTupleTpListDict(recoders_dictionary,['id_code','value','inner_code','location_type','mi_style'])
                ''' Справочник ObjectKey'''
                default_value=DefaultValueField(dictionary_values[0]['id_code'],dictionary_values[-1]['id_code'],dictionary_values[0]['id_code'],dictionary_values[0]['location_type'],dictionary_values[0]['mi_style'])
            else:

                sql_dictionary = "select * from " + name_dictionary_tab
                recoders_dictionary = dbRsc.select(sql_dictionary)
                dictionary_values = listTupleTpListDict(recoders_dictionary,['id_code','value'])
                sql="select * from "+DbTableInfo.DefaultValue+" where code="+str(inner_code)
                record_default=dbRsc.select(sql)
                min_value=record_default[0][2]
                def_value=record_default[0][3]
                max_value=record_default[0][4]
                default_value = DefaultValueField(min_value, max_value,def_value)

            cls_fk_key=ForeignKeyField(name_field_db,name_field_db,name_dictionary_tab,dbRsc.PathDb,name_id_key,name_field_dict,dictionary_values,default_value)
            dictionarys.append(cls_fk_key)

        table_relation=TableRelation(nameTableLower,nameTable,path_source,dictionarys)
        #dbRsc.runSqlNoResult("DETACH DATABASE '" + DbTableInfo.SpatialDb + "'")
        return table_relation












