def findMin(pts,id):
    value_min=min(pts, key = lambda t: t[id])
    return value_min[id]
def findMax(pts,id):
    value_max=max(pts, key = lambda t: t[id])
    return value_max[id]
def multiplyPoints(points,coef)->list:
    out_points = []
    for pnt in points:
        out_points.append((pnt[0] * coef, pnt[1] *coef))
    return out_points

class PointPath:
    def __init__(self,points=None):
        self.__minX=None
        self.__maxX=None
        self.__minY = None
        self.__maxY = None
        if points is None:
            self.__points=[]
        else:
            self.__minX=findMin(points,0)
            self.__minY = findMin(points, 1)
            self.__maxX = findMax(points, 0)
            self.__maxY = findMax(points, 1)
            self.__points=points

    def add(self,point:tuple):
        if len(self.__points)==0:
            self.__minX=self.__maxX=point[0]
            self.__minY = self.__maxY = point[1]
        else:
            self.__minX=min(self.__minX,point[0])
            self.__minY = min(self.__minY, point[1])
            self.__maxX = max(self.__maxX, point[0])
            self.__maxY = max(self.__maxY, point[1])

        self.__points.append(point)
    @property
    def MinX(self):
        return self.__minX
    @property
    def MaxX(self):
        return self.__maxX

    @property
    def MinY(self):
        return self.__minY

    @property
    def MaxY(self):
        return self.__maxY
    def standardization(self)->list:
        width=self.__maxX-self.__minX
        '''
        out_points=[]
        for pnt in self.__points:
            out_points.append((pnt[0]/width,pnt[1]/width))
        '''
        out_points=multiplyPoints(self.__points,1.0/width)
        return out_points
    def clone(self,coeficient=None,normali=True):
        if coeficient is None:
            new_path=PointPath(self.__points.copy())
            return new_path
        norm_points=self.standardization()
        new_points=multiplyPoints(norm_points,coeficient)
        return PointPath(new_points)
    def buildPathString(self,offset_x=0.0,offset_y=0.0):
        str_path=""
        cmd="M"
        patern=" {cmd} {x:.2f} {y:.2f}"
        for pnt in self.__points:

            str_path=str_path+patern.format(cmd=cmd,x=pnt[0]+offset_x,y=pnt[1]+offset_y)
            cmd="L"
        return str_path[1:]



