from pathlib import Path

from PySide2.QtGui import QImage
import fileinput

#from MyTask.Panorama.RSC.image_cls.imageMask32.helper import imageToBytes
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.image_cls.imageMask32.helper import imageToBytes


def readImageBytes(path_file):
    data_image=None
    with open(path_file, 'rb') as f:
        data_image=bytearray(f.read())
    return data_image
def writeImageBytes(data_image,path_out):
    with open(path_out, "wb") as binary_file:
        binary_file.write(data_image)
def updateXpm(path_xmp):
    with fileinput.FileInput(path_xmp, inplace=True, backup='.bak') as file:

        for line in file:
            line=line.replace("#ffffff",'None')
            print(line, end='')
    path_temp=Path(path_xmp)
    path_bak=path_temp.parent.joinpath(str(path_temp.name)+".bak")
    if path_bak.exists():
        path_bak.unlink()

class BrushStyles:
    __extend_file=".xpm"
    def __init__(self,path_folder_brush=None):
        if path_folder_brush is not None:
            self.__path_brush=Path(path_folder_brush)
            self.__count_files=sum(1 for x in  self.__path_brush.glob('xmp') if x.is_file())
            self.__cache_image = {}
    def setPath(self,path_folder_brush):
        self.__cache_image={}
        self.__path_brush = Path(path_folder_brush)
        self.__count_files = sum(1 for x in self.__path_brush.glob('xmp') if x.is_file())
    def addFileImage(self,image:QImage):
        list_files=self.__getListFiles()
        self.__count_files=len(list_files)
        name_exist_file=self.__existFile(list_files,image)
        if name_exist_file is not None:
            name=name_exist_file.replace('pat','')
            name=name.replace('.xpm','')
            return int(name)


        name_file="pat"+"{:03d}".format(self.__count_files+1)+self.__extend_file
        full_path=self.__path_brush.joinpath(name_file)
        image.save(str(full_path),"XPM")
        updateXpm(str(full_path))
        return self.__count_files+1
    def addFile(self,image_data):
        if isinstance(image_data,QImage):
            image = imageToBytes(image_data, "XPM")
            image = image.replace(b"#ffffff", b'None')

        list_files=self.__getListFiles()
        self.__count_files=len(list_files)
        name_exist_file=self.__existFile(list_files,image)
        if name_exist_file is not None:
            name=name_exist_file.replace('pat','')
            name=name.replace('.xpm','')
            return int(name)


        name_file="pat"+"{:03d}".format(self.__count_files+1)+self.__extend_file
        full_path=self.__path_brush.joinpath(name_file)
        #image.save(str(full_path),"XPM")
        #updateXpm(str(full_path))
        writeImageBytes(image,str(full_path))
        return self.__count_files+1
    def __getListFiles(self):
        list_files_iter=self.__path_brush.glob('*'+self.__extend_file)
        list_files=[]
        for fname in list_files_iter:
            list_files.append(fname)
        return list_files
    def __existFileImage(self,list_files,image):
        if len(list_files)==0:
            return None
        for file in list_files:
            name = file.stem
            if name in self.__cache_image:
                cur_image=self.__cache_image[name]
                if cur_image == image:
                    return name
                continue
            name_file = str(file)
            cur_image = QImage()
            cur_image.load(name_file)
            name=file.stem

            self.__cache_image[name]=cur_image

            if cur_image == image:
                return file.stem
        return None
    def __existFile(self,list_files,image):
        if len(list_files)==0:
            return None
        for file in list_files:
            name = file.stem
            if name in self.__cache_image:
                cur_image=self.__cache_image[name]
                if cur_image == image:
                    return name
                continue
            name_file = str(file)
            cur_image = readImageBytes(name_file)

            name=file.stem

            self.__cache_image[name]=cur_image

            if cur_image == image:
                return file.stem
        return None
    def getImageBrush(self,id_image):
        name="pat"+"{:03d}".format(id_image)
        name_file=name+self.__extend_file
        if name in self.__cache_image:
            data_image=self.__cache_image[name]
            out_image = QImage()
            out_image.loadFromData(data_image)
            return out_image
        path_brush_curent=str(self.__path_brush.joinpath(name_file))
        out_image = QImage()
        out_image.load(path_brush_curent)
        return out_image

brush_style_container=BrushStyles()