from PySide2.QtCore import Qt
from PySide2.QtGui import QImage, QPainter

#from MyTask.Panorama.RSC.add_help.saveBrush.cls_saveBrush import brush_style_container
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.add_help.saveBrush.cls_saveBrush import brush_style_container

def mergeTwoImage(image1,image2):
    resultImage=QImage(image1.size(), QImage.Format_ARGB32_Premultiplied)
    painter=QPainter(resultImage)
    painter.setCompositionMode(QPainter.CompositionMode_Source)
    painter.fillRect(resultImage.rect(), Qt.transparent)
    painter.setCompositionMode(QPainter.CompositionMode_SourceOver)
    painter.drawImage(0, 0, image1)
    painter.drawImage(0, 0, image2)
    painter.setCompositionMode(QPainter.CompositionMode_DestinationOver)
    painter.end()
    return resultImage
class BrushStyle:
    def __init__(self,str_brush):
        self.__id_brush=None
        self.__color=None
        self.__color_fon=None
        self.__parser(str_brush)
    def __parser(self,str_brush):
        temp_style=str_brush.replace("Brush","")
        temp_style = temp_style.replace("(", "")
        temp_style = temp_style.replace(")", "")
        prams=temp_style.split(",")
        if len(prams)<2:
            return
        self.__id_brush=int(prams[0])
        self.__color=int(prams[1])
        if len(prams)==3:
            self.__color_fon=int(prams[2])
    @property
    def idBrush(self):
        return self.__id_brush
    @property
    def color(self):
        return self.__color
    @property
    def fon_color(self):
        return self.__color_fon
def MergeImageBrush(str_brush):
    if isinstance(str_brush,str):
        list_brush=str_brush.split(";")
    else:
        list_brush=str_brush
    if len(list_brush)<2:
        return None
    brushs=[]
    for str_brush in list_brush:
        br=BrushStyle(str_brush)
        if br.idBrush is not None:
            brushs.append(br)
    if len(brushs)<2:
        return None
    ''' условия объедиения
    1 - одинаковый цвет
    2 - одинаковый размер 
    '''
    base_color=brushs[0].color
    is_equ_color=True
    for brh in brushs:
        if brh.color!=base_color:
            is_equ_color=False
            return None
    image_brush=[]
    for brush in brushs:
        image=brush_style_container.getImageBrush(brush.idBrush)
        image_brush.append(image)
    base_size=image_brush[0].size()
    for i in range(1,len(image_brush)):
        if base_size!=image_brush[i].size():
            return None
    if len(image_brush)==2:
        merge_image=mergeTwoImage(image_brush[0],image_brush[1])
        id_new_brush=brush_style_container.addFile(merge_image)
        new_brush_style="Brush("+str(id_new_brush)+","+str(brushs[0].color)
        if brushs[0].fon_color is not None:
            new_brush_style =new_brush_style+","+str(brushs[0].fon_color)
        new_brush_style = new_brush_style+")"
        return new_brush_style
    return None