import json


class SaveSymbol:
    def __init__(self,cls_db,name_out_tab='display_param_values'):
        self.__cls_db=cls_db
        self.__name_tab=name_out_tab
    def save(self,inner_code,ext_code,params):

        if isinstance(params,dict):
            param_temp=params.copy()
            image=params['image']
            del param_temp['image']
            self.__saveItem(inner_code,ext_code,0,self.__paramJsToText(param_temp),image)
            return
        for i,item in enumerate(params):
            if isinstance(item,list):
                self.save(inner_code,ext_code,item)
                continue
            param_temp = item.copy()
            image = item['image']
            del param_temp['image']
            self.__saveItem(inner_code,ext_code, i, self.__paramJsToText(param_temp), image)
        return
    def __saveItem(self,inner_code,extension_number,id_item,param_js,image):
        sql_save="insert into "+self.__name_tab+" (inner_code,extension_number,id_sym,params_js,image) VALUES(?,?,?,?,?)"
        param=(inner_code,extension_number,id_item,param_js,image)
        self.__cls_db.insert(sql_save,param)
        return
    def __paramJsToText(self,param_js)->str:
        return json.dumps(param_js, indent=4)
    def clearTable(self):
        sql="delete from "+self.__name_tab
        self.__cls_db.runSqlNoResult(sql)
