from axipy import Attribute

#from MyTask.Panorama.PanoramaMap.add_tools.db_add_helper import ObjectDictionary, RscLayer
from PanoramaRsc.ui.add_tools.rsc_tools.PanoramaMap.add_tools.db_add_helper import ObjectDictionary, RscLayer, \
    TypeGeometry


def findInListDict(list,val_find,key='short_name'):
    for item in list:
        if item[key]==val_find:
            return item
    return None
class RscDbTools:
    __name_table_layer="layers"
    __name_full_name_layers='full_names_layers'
    __name_layers_attribute='layers_attribute'
    __name_semantic_attribute='semantic_attribute'
    __name_object_semantic_required_possible='object_semantic_required_possible'
    __name_objects='objects'
    __sql_layer_info="select l.*,f.name as full_name from "+__name_table_layer+" l,"+__name_full_name_layers+" f where l.id_layer=f.code_object"
    def __init__(self,dbRsc):
        self.__db=dbRsc
        self.__list_layers=None
    def getSchemaLayer(self,nameLayer,onlyRequired=True):
        if isinstance(nameLayer,int):
            layer_info=self.__list_layers[nameLayer]
        else:
            layer_info=findInListDict(self.__list_layers,nameLayer)
        ''' получаем список атрибутов для слоя '''
        sql="select * from "+self.__name_layers_attribute+" where num_layer="+str(layer_info['id'])
        records_att=self.__db.select(sql)
        list_att_codes=[]
        for row in records_att:
            code=row[1]
            sematic_description=self.__getInfoCodeSemantic(code)
            if sematic_description is None:
                continue
            isRequired=self.__semanticRequired(layer_info['id'],code)
            list_att_codes.append({'code_att':row[1],"sematic":sematic_description,"required":isRequired})

        list_attribute_axipy=[]
        for layer in list_att_codes:
            if onlyRequired:
                if not layer["required"]:
                    continue

            att=self.__AttributeAxi(layer['sematic'])
            if att is None:
                continue
            list_attribute_axipy.append(att)
        return layer_info,list_attribute_axipy
    def __AttributeAxi(self,att_code_property):
        att=None
        name=att_code_property['short_name']
        if att_code_property['type']==1:
            ''' число '''
            if att_code_property['precisssion']==0:
                '''integer'''
                att=Attribute.integer(name)
            else:
                att=Attribute.double(name)
        if att_code_property['type'] == 16:
            att = Attribute.integer(name)
        if att_code_property['type']==0:
            '''text'''
            att=Attribute.string(name,att_code_property['length'])
        if att_code_property['type']==24:
            att = Attribute.string(name, att_code_property['length'])
        if att_code_property['type']==22:
            att = Attribute.double(name)
        return att
    def __semanticRequired(self,id_layer,code):
        sql='select r.* from (select * from '+self.__name_object_semantic_required_possible+' where code_semantic='+str(code)+' and is_required=1) r,(select code from '+self.__name_objects+' where layer_number='+str(id_layer)+') obj where r.code_object=obj.code'
        records=self.__db.select(sql)
        if len(records)>0:
            return True
        return False
    def __getInfoCodeSemantic(self,code):
        sql="select * from "+self.__name_semantic_attribute+" where code="+str(code)
        recodes=self.__db.select(sql)
        if len(recodes)==0:
            return None
        row=recodes[0]
        semantic_desc={}
        semantic_desc['code']=row[0]
        semantic_desc['type']=row[1]
        semantic_desc['name']=row[4]
        semantic_desc['short_name']=row[5]
        semantic_desc['units']=row[6]
        semantic_desc['length'] = row[7]
        semantic_desc['precisssion'] = row[8]
        return semantic_desc


    def loadLayersInfo(self):
        self.getLayersInfo()
        return len(self.__list_layers)

    def getLayersInfo(self):
        if self.__list_layers is not None:
            return self.__list_layers
        records=self.__db.select(self.__sql_layer_info)
        if len(records)==0:
            return None
        self.__list_layers=[]
        for row in records:
            layer_info={}
            layer_info['id']=row[0]
            layer_info['name'] = row[1]
            layer_info['short_name'] = row[2]
            layer_info['display_order'] = row[3]
            layer_info['full_name'] = row[4]
            self.__list_layers.append(layer_info)
        return self.__list_layers
    def prepareDictionary(self,parent_cls):
        ''' Создание справочника по полям Object'''
        if parent_cls is not None:
            parent_cls.send_status.emit("Create dictionary by object")
            parent_cls.send_status.emit("....")
        self.__createAttributesClsaaDictionary()
        ''' Подготовка справочников для слоев '''
        if parent_cls is not None:
            parent_cls.send_status.emit("Подготовка справочников для слоев")
        name_table_layers_info = "layer_info_dict_spatial"
        sql="CREATE TABLE ["+name_table_layers_info+"]([id_layer] INTEGER PRIMARY KEY,[name] TEXT,[short_name] TEXT,[full_name] TEXT,[type_geometry] INTEGER, [display_orderIndex] INTEGER)"
        self.__db.runSqlNoResult(sql)
        if self.__list_layers is None:
            self.getLayersInfo()
        if parent_cls is not None:
            parent_cls.send_status.emit("....")
        self.__createForeign_key_layers()
        sql_fk_key = "Insert into foreign_key_layers (id_layer, name_children_dict,name_field_base ,name_field_fk,name_filed_children,code,type_key)  VALUES(?, ?,?,?,?,?,?)"
        sql_insert_info_layer = "Insert into " + name_table_layers_info + "(id_layer,name,full_name,type_geometry,display_orderIndex) VALUES(?,?,?,?,?)"
        if self.__list_layers is not None:
            for layer_info in self.__list_layers:
                if layer_info['id']==0:
                    continue
                if parent_cls is not None:
                    parent_cls.send_status.emit("Формирование информации по слою:"+layer_info['name'])
                layer=RscLayer.factory(self.__db,layer_info['id'])
                objects_dict, type_geometry = ObjectDictionary.factoryDictonary(self.__db, layer_info['id'])
                name_dict_objectkey="layer_"+str(layer_info['id'])+"_objectkey"
                name_tab_db=factoryObjectIdDictionaryDb(self.__db,name_dict_objectkey,objects_dict)
                record = (layer_info['id'],name_dict_objectkey, "objectkey", "id_code", "value",0, 1)
                self.__db.insert(sql_fk_key, record)

                type_geometry = 0
                if isinstance(layer.TypeGeometry, int):
                    type_geometry = layer.TypeGeometry
                else:
                    type_geometry = layer.TypeGeometry.value
                '''
                if type_geometry!=type_common_geometry.value:
                    type_geometry=type_common_geometry.value
                '''
                values = (layer.IdLayer, layer.Name, layer.FullName, type_geometry, layer.OrderDisplay)
                self.__db.insert(sql_insert_info_layer, values)
                ''' Добавляем справочники на поля '''
                for att in layer.Attribute:
                    self.__add_dictionary_on_field(layer.IdLayer, att)
    def __createForeign_key_layers(self):
        sql="CREATE TABLE foreign_key_layers (id_layer INTEGER, name_children_dict TEXT,name_field_base TEXT,name_field_fk TEXT,name_filed_children TEXT, code INTEGER,type_key INTEGER)"
        self.__db.runSqlNoResult(sql)
        sql="CREATE INDEX fk_layer_children_dict ON foreign_key_layers](id_layer)"
        self.__db.runSqlNoResult(sql)
    def __add_dictionary_on_field(self,id_layer,att):
        name_view = 'attributes_dict_' + str(att.InnerCode)
        sql='SELECT name from sqlite_master  WHERE type ="table" and name = "'+name_view+'"'
        records=self.__db.select(sql)
        if len(records)==0:
            return
        sql="Insert into foreign_key_layers (id_layer, name_children_dict,name_field_base ,name_field_fk,name_filed_children,code,type_key)  VALUES(?, ?,?,?,?,?,?)"
        record = (id_layer, name_view, att.Name.lower(),"id_code","value",att.InnerCode,0)
        self.__db.insert(sql, record)
    def __createAttributesClsaaDictionary(self):
        name_tab = 'classificator_values'
        sql = "select Min(id) ,Max(id) from " + name_tab
        records = self.__db.select(sql)
        min_code = records[0][0]
        max_code = records[0][1]
        for code in range(min_code,max_code+1):
            sql_source="select * from "+name_tab+" where id="+str(code)
            records=self.__db.select(sql_source)
            if len(records)==0:
                continue
            name_tab_new = 'attributes_dict_' + str(code)
            sql_create_table="CREATE TABLE "+name_tab_new+" AS SELECT code as id_code,name as value from "+name_tab+" where id="+str(code)
            self.__db.runSqlNoResult(sql_create_table)
def factoryObjectIdDictionaryDb(dbRsc,name_tab,dictionary_main_objectId):
    #name_tab=name_layer+"_dict_object_id"
    sql="create table "+name_tab+" (id_code TEXT,value TEXT, type_geometry INTEGER, "
    sql=sql+" CONSTRAINT object_key UNIQUE (id_code) )"
    dbRsc.runSqlNoResult(sql)
    sql_insert = "Insert into " + name_tab + " (id_code, value,type_geometry)  VALUES(?, ?,?)"
    min_len_obj_key=10000
    #type_geometry_dict=[]
    for att in dictionary_main_objectId:
        min_len_obj_key=min(min_len_obj_key,len(att.ObjectKey))
        '''
        if isinstance(att.TypeGeometry,int):

            curent_type_geometry=TypeGeometry(att.TypeGeometry)
        else:
            curent_type_geometry = att.TypeGeometry
        if not (curent_type_geometry in type_geometry_dict):
            type_geometry_dict.append(curent_type_geometry)


    if len(type_geometry_dict)>1:
        common_type_geometry = TypeGeometry.Any
    else:
        common_type_geometry=type_geometry_dict[0]
    '''

    values=[]
    for att in dictionary_main_objectId:
        if len(att.ObjectKey)>min_len_obj_key:
            continue
        #rcord=(att.ObjectKey,att.Name)
        #dbRsc.insert(sql_insert,rcord)
        if isinstance(att.TypeGeometry, int):
            type_geometry = att.TypeGeometry
        else:
            type_geometry = att.TypeGeometry.value
        values.append((att.ObjectKey,att.Name,type_geometry))
    #sql_insert="Insert into "+name_tab+" (id_code, value)  VALUES(?, ?)"
    dbRsc.insertMany(sql_insert,values)
    return name_tab




