import json

from PIL import Image
import io

from PIL.ImageStat import Stat
from PIL.PngImagePlugin import PngImageFile

#from MyTask.Panorama.RSC.add_help.dbRsc import DbRsc, DbRscTableNames
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.add_help.dbRsc import DbRsc, DbRscTableNames


def isWhite(img):
    stat=Stat(img)
    try:
        img_mean=stat.mean
        if img_mean[0]==255 and img_mean[1]==255 and img_mean[2]==255:
            return True
    except:
        pass
    return False
def getImage(bytes):
    image = Image.open(io.BytesIO(bytes))
    return image
def imagePaste(img_base:Image,img_paste:Image)->Image:
    img_out=Image.new("RGBA", img_base.size)
    img_out.paste(img_base)
    w_b,h_b=img_out.size
    b_cx=w_b/2
    b_cy=h_b/2
    w_p,h_p=img_paste.size
    x_lu=int(b_cx-w_p/2)
    y_lu=int(b_cy-h_p/2)
    img_out.paste(img_paste,(x_lu,y_lu))
    return img_out
def imagePasteAlphaOld(img_base:Image,img_paste:Image)->Image:
    img_out=Image.new("RGBA", img_base.size)
    img_out.paste(img_base)
    w_b,h_b=img_out.size
    b_cx=w_b/2
    b_cy=h_b/2
    w_p,h_p=img_paste.size
    x_lu=int(b_cx-w_p/2)
    y_lu=int(b_cy-h_p/2)
    img_temp = Image.new("RGBA", img_base.size)
    img_temp.paste(img_paste,(x_lu,y_lu))
    img_out.alpha_composite(img_temp)
    return img_out
def imagePasteAlphaZ(img_base:Image,img_paste:Image)->Image:
    img_out=Image.new("RGBA", img_base.size)
    img_out.paste(img_base)
    img_temp=img_paste.resize((80,80))
    w_b,h_b=img_out.size
    b_cx=w_b/2
    b_cy=h_b/2
    w_p,h_p=img_temp.size
    x_lu=int(b_cx-w_p/2)
    y_lu=int(b_cy-h_p/2)

    img_out.alpha_composite(img_temp,(x_lu,y_lu))
    return img_out
def imagePasteAlph(img_base:Image,img_paste:Image)->Image:
    img_out=Image.new("RGBA", img_base.size)
    img_out.paste(img_base)
    #img_temp=img_paste.resize((80,80))
    w_b,h_b=img_out.size
    b_cx=w_b/2
    b_cy=h_b/2
    w_p,h_p=img_paste.size
    x_lu=int(b_cx-w_p/2)
    y_lu=int(b_cy-h_p/2)

    img_out.alpha_composite(img_paste,(x_lu,y_lu))
    return img_out
def imagePasteAlphNext(img_base:Image,img_paste:Image)->Image:

    w_b,h_b=img_base.size
    b_cx=w_b/2
    b_cy=h_b/2
    w_p,h_p=img_paste.size
    x_lu=int(b_cx-w_p/2)
    y_lu=int(b_cy-h_p/2)

    img_base.alpha_composite(img_paste,(x_lu,y_lu))
    return img_base
class VirtualImage:
    def __init__(self,params,bytes_image):
        self.IsWhite = False
        self.__params=params
        self.__img=None
        self.__load(bytes_image)

    def __load(self,bytes):
        if isinstance(bytes,PngImageFile):
            self.__base_image=bytes
        else:
            self.__base_image=getImage(bytes)
        self.IsWhite=isWhite(self.__base_image)
        coef=(int(self.__params['height'])/int(self.__params['pixel_h']))/100
        size_h=int(int(self.__params['pixel_h'])*coef)
        if size_h==int(self.__params['pixel_h']):
            self.__img=self.__base_image
        else:
            h=int(int(self.__params['pixel_h'])*coef)
            w=int(int(self.__params['pixel_w'])*coef)
            self.__img=self.__base_image.resize((w, h))
    @property
    def image(self):
        return self.__img
class ExtTerplan6_4:
    __extention_number=4
    def __init__(self,path_image):
        self.__img=Image.open(path_image)
    @property
    def extentionNumber(self):
        return self.__extention_number
    @property
    def image(self):
        return self.__img
    @staticmethod
    def factory(path_image):
        try:
            cls_ext=ExtTerplan6_4(path_image)
            return cls_ext
        except:
            return None

class FactorySymbolPoint:
    __def_name_tab="display_param_values"
    __patern_sql="Select * from {name_tab} where inner_code={id} order by id_sym"
    def __init__(self,clsDb:DbRsc,noUseWhite=False):
        self.__db=clsDb
        self.__exention_function=None
        self.__no_use_first_white=noUseWhite
    def setExtentionFunction(self,ext_function):
        self.__exention_function=ext_function
    def load(self,id):
        sql=self.__patern_sql.format(name_tab=self.__def_name_tab,id=str(id))
        rows=self.__db.select(sql)
        picteres=[]
        count=len(rows)
        for i,row in enumerate(rows):
            params=json.loads(row[2])
            ext_number=row[3]
            image=row[4]
            if image is None:
                continue
            if self.__exention_function is not None and ext_number==self.__exention_function.extentionNumber and i==(count-1):
                imege_vrt=VirtualImage(params,self.__exention_function.image)
                #picteres.append(imege_vrt)
            else:
                imege_vrt =VirtualImage(params,image)
                #picteres.append(VirtualImage(params,image))
            if not imege_vrt.IsWhite:
                picteres.append(imege_vrt)
        if len(picteres)==0:
            return None
        if len(picteres)==1:
            return picteres[0].image
        if len(picteres)==2:
            out_image=imagePasteAlph(picteres[0].image,picteres[1].image)
            return out_image
        out_image = imagePasteAlph(picteres[0].image, picteres[1].image)
        for i in range(2,len(picteres)):
            out_image=imagePasteAlphNext(out_image,picteres[i].image)
        return out_image
class FactorySymbolPointMemory:
    def __init__(self,noUseWhite=False):
        self.__exention_function = None
        self.__no_use_first_white = noUseWhite
    def build(self,params):
        picteres = []
        for i, row in enumerate(params):
            if isinstance(row,list):
                for j,item in enumerate(row):
                    image=item['image']
                    if image is None:
                        continue
                    image_vrt = VirtualImage(item, image)
                    if not image_vrt.IsWhite:
                        picteres.append(image_vrt)
            else:
                image=row['image']
                if image is None:
                    continue
                image_vrt = VirtualImage(row, image)
                if image_vrt.IsWhite and  self.__no_use_first_white:
                    picteres.append(image_vrt)
                    continue


                picteres.append(image_vrt)
        if len(picteres)==0:
            return None
        if len(picteres)==1:
            return picteres[0].image
        if len(picteres)==2:
            out_image=imagePasteAlph(picteres[0].image,picteres[1].image)
            return out_image
        out_image = imagePasteAlph(picteres[0].image, picteres[1].image)
        for i in range(2,len(picteres)):
            out_image=imagePasteAlphNext(out_image,picteres[i].image)
        return out_image



class StyleDb:
    def __init__(self,dbRsc:DbRsc):
        self.__db=dbRsc
    def setStyle(self,inner_code,mi_style:str):
        sql="update "+DbRscTableNames.NameDisplayParametrs+" set mi_style='"+mi_style+"' where inner_cod="+str(inner_code)
        self.__db.runSqlNoResult(sql)






