import struct

from PanoramaRsc.ui.add_tools.rsc_tools.RSC.cls_rsc import getString


#from MyTask.Panorama.RSC.cls_rsc import getString


class Palettes:
    def __init__(self,name,colors):
        self.__name=name
        self.__colors=colors
    @property
    def Name(self):
        return self.__name

    def getColotByIndex(self,id_color):
        return self.__colors[id_color]
    @staticmethod
    def factory(bytes,offset,count_color):
        struct_color=struct.Struct('< B B B B')
        colors=[]

        for i in range(count_color):
            curent_offset=offset+i*struct_color.size
            buf=bytes[curent_offset:curent_offset+struct_color.size]
            data=struct_color.unpack(buf)
            colors.append(data)
        curent_offset = curent_offset+ struct_color.size
        buf_name=bytes[curent_offset:curent_offset+32]
        name_pal=getString(buf_name)
        return Palettes(name_pal,colors)

class RscPrintPrametrs:
    def __init__(self):
        self.__pallets=None
    def addPalette(self,cls_pallet):
        if self.__pallets is None:
            self.__pallets=[]
        self.__pallets.append(cls_pallet)
    def getPallets(self,id_pal):
        return self.__pallets[id_pal]
    def getColor(self,id_pal,id_color):
        pal= self.__pallets[id_pal]
        color=pal.getColotByIndex(id_color)
        return color


def factoryRscPrintPrametrs(bytes):
    #offset = bytes.find(b'PAL')
    __struct=struct.Struct('< I I I')
    offset=216
    ''' Число таблиц'''
    count_table=6
    list_tables_info=[]
    for i in range(count_table):

        buf=bytes[offset+__struct.size*i:offset+__struct.size*(i+1)]
        data =__struct.unpack(buf)
        info_tab={'offset':data[0],'size':data[1],'count':data[2]}
        list_tables_info.append(info_tab)
    __struct_add = struct.Struct('< B B 30s I I')
    offset=offset+__struct.size*count_table
    buf=bytes[offset:offset+__struct_add.size]
    data=__struct_add.unpack(buf)
    pallet_colors=data[4]
    palettes=Palettes.factory(bytes,list_tables_info[1]['offset'],pallet_colors)
    cls_printParams=RscPrintPrametrs()
    cls_printParams.setPalette(palettes)
    return cls_printParams

