from PySide2.QtCore import QObject, Signal
from loguru import logger

from PanoramaRsc.ui.add_tools.helper_db.db_add_helper import writeFileToBlob
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.add_help.dbRsc import DbRsc
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.add_help.tool_db_rsc import RscDbTools
from PanoramaRsc.ui.add_tools.rsc_tools.RSC.cls_rsc import loadRscToDb


class ConvertorRscToDB(QObject):
    send_status=Signal(str)
    def __init__(self,path_rsc,path_out_db):
        super().__init__()
        self.__source_rsc=path_rsc
        self.__dest_dict_db=path_out_db
    def setPath(self,path_rsc,path_out_db):
        self.__source_rsc = path_rsc
        self.__dest_dict_db = path_out_db
    def run(self):
        logger.debug("Start convert")
        logger.debug("Source Rsc:"+self.__source_rsc)
        logger.debug("Dest db:" + self.__dest_dict_db)
        self.send_status.emit("Source Rsc:"+self.__source_rsc)
        self.send_status.emit("Dest db:" + self.__dest_dict_db)
        loadRscToDb(self,self.__source_rsc,self.__dest_dict_db)
        self.send_status.emit("End prepare rsc")
        dbCls = DbRsc(self.__dest_dict_db)
        isConnect = dbCls.connect()
        rsdDb = RscDbTools(dbCls)
        rsdDb.prepareDictionary(self)
        #dbCls.close()
        #db = DbRsc(self.__dest_dict_db)
        self.send_status.emit("Write rsc file to db")
        writeFileToBlob(dbCls, "table_rsc", self.__source_rsc)
        #db.close()
        dbCls.close()
        self.send_status.emit("End convert")