import glob
import io
import json
import os
from pathlib import Path

import axipy
from datetime import datetime
#name_folder="PanoramaRsc"
class ConfigRscDict:
    path_folder=None
    path_active_file=None
    def __init__(self,path_dict=None,path_db=None):
        if path_dict is not None:
            self.__path_dict_rsc=Path(path_dict)
        else:
            self.__path_dict_rsc=path_dict
        if path_db is not None:
            self.__db=Path(path_db)
        else:
            self.__db=path_db
        #self.__pathFolder=axipy.CurrentSettings.UserDataFolder.joinpath(name_folder)
        self.__pathFolder=ConfigRscDict.path_folder
        if self.__pathFolder is None:
            return
        if not self.__pathFolder.exists():
            os.mkdir(str(self.__pathFolder))

    @property
    def PathRscDb(self):
        return self.__path_dict_rsc
    @PathRscDb.setter
    def PathRscDb(self,value):
        if isinstance(value,Path):
            self.__path_dict_rsc=value
        else:
            self.__path_dict_rsc = Path(value)
    def setPathRscDb(self,value):
        if isinstance(value,Path):
            self.__path_dict_rsc=value
        else:
            self.__path_dict_rsc = Path(value)
    @property
    def PathDb(self):
        return self.__db
    @PathDb.setter
    def PathDb(self,value):
        if isinstance(value,Path):
            self.__db=value
        else:
            self.__db = Path(value)
    def setPathDb(self,value):
        if isinstance(value,Path):
            self.__db=value
        else:
            self.__db = Path(value)
    @property
    def pathData(self):
        return self.__pathFolder
    def save(self):
        if self.__path_dict_rsc is None or self.__db is None:
            return
        curent_date= datetime.now().strftime("%Y_%m_%d_%H_%M")
        name_file=str(self.__path_dict_rsc.stem)+"_"+str(self.__db.stem)+"_"+curent_date+".json"
        path_file=str(self.__pathFolder.joinpath(name_file))
        json_data={}
        json_data['path_db_rsc']=str(self.__path_dict_rsc)
        json_data['path_db_data'] = str(self.__db)
        with io.open(path_file, 'w', encoding='utf8') as json_file:
            json.dump(json_data, json_file, ensure_ascii=False)
        ConfigRscDict.path_active_file=path_file
    @staticmethod
    def load(pathFolder=None,name=None):
        if pathFolder is None and ConfigRscDict.path_active_file is not None:
            return ConfigRscDict.loadFromFile(ConfigRscDict.path_active_file)
        if pathFolder is not None:
            if isinstance(pathFolder,str):
                ConfigRscDict.path_folder=Path(pathFolder)
            else:
                ConfigRscDict.path_folder=pathFolder
        cls=ConfigRscDict()
        filter_file=str(cls.pathData.joinpath("*.json"))
        files = glob.glob(filter_file)
        if len(files)==0:
            return None
        files.sort(key=os.path.getmtime, reverse=True)
        curent_file=files[0]
        data_json=None
        with open(curent_file, encoding='utf-8') as fh:
            data_json = json.load(fh)
        cls.setPathRscDb(data_json['path_db_rsc'])
        cls.setPathDb(data_json['path_db_data'])
        return cls
    @staticmethod
    def loadFromFile(path_file_config):
        data_json = None
        with open(path_file_config, encoding='utf-8') as fh:
            data_json = json.load(fh)
        if data_json is None:
            return None
        cls = ConfigRscDict()
        cls.setPathRscDb(data_json['path_db_rsc'])
        cls.setPathDb(data_json['path_db_data'])
        ConfigRscDict.path_active_file=path_file_config
        return cls





