import axipy
from axipy import Layer, Map


def view_map_from_db(layers_name:list,path_db,title:str=None):
    layers=[]
    for name in layers_name:

        def_table= {'src': path_db,
                      'dataobject': name,
                      'provider': 'SqliteDataProvider'
                      }
        table=axipy.provider_manager.open(def_table)
        layers.append(Layer.create(table))
    map = Map(layers)
    map_view=axipy.view_manager.create_view(map)
    if title is not None:
        map_view.title=title
    return map_view
