import os

import axipy
from PySide2.QtCore import QObject
from PySide2.QtGui import QIcon

from PanoramaRsc.ui.docWidget import AxiDocWidget, addDoc, existDocWidget
from PanoramaRsc.ui.formConvertRscToDb import RscToDb


class ConvertRscToDbDict(QObject):
    def __init__(self,parent_plugin):
        super().__init__()
        self.__name_doc="Импорт Rsc в базу данных справочника"
        self.__parent_plugin=parent_plugin
        self.__form_tool = None
        self.__docWidget = None
        self.__local_file_icon_tools = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons',
                                                    'rscToDb.png')

        self.__iconTools = QIcon(self.__local_file_icon_tools)
        self.__title = self.tr("Импорт Rsc")
        self.__action = self.__parent_plugin.create_action(
            self.__title,
            icon=self.__local_file_icon_tools,
            on_click=self.__show_control,
            tooltip="Импорт Rsc в базуданных спрвочника"
        )

    @property
    def action(self):
        return self.__action

    def __show_control(self):
        if self.__form_tool is None:
            self.__form_tool = RscToDb(axipy.mainwindow.qt_object())
        if self.__docWidget is None:

            self.__docWidget = AxiDocWidget(self.__form_tool.widget, self.__name_doc, self.__name_doc,
                                                QIcon(), axipy.view_manager.global_parent)
            addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)
        else:
            isExist = existDocWidget(axipy.view_manager.global_parent, self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    def unload(self):
        if self.__docWidget is not None:
            axipy.mainwindow.qt_object().removeDockWidget(self.__docWidget)
            self.__docWidget=None

