import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog

from PanoramaRsc.ui.widgetExportGml import ExportGml


class DlgExportGml(QDialog):
    def __init__(self,cls_config,parent=None):
        super().__init__(parent)
        self.__config_dict=cls_config
        self.ui=self.load_ui("DlgExportGmlFgistTp.ui",parent)
        self.__widget=ExportGml(self.__config_dict,self.ui)
        self.ui.verticalLayout.addWidget(self.__widget.ui)
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def show(self):
        self.ui.show()
    def exec_(self):
        self.ui.exec_()
    def finished(self):
        self.__widget.finished()

